% Plots bubbel dew and Critical points for the three separators S1, S2 and
% S3
clc
clear
close all
load('BubbleDew')

figure(1)
subplot(2,2,1)
hold on
plot(BubblePtS1(:,2),BubblePtS1(:,1)*10^-2,'r','linewid',2);
plot(DewPtS1(:,2),DewPtS1(:,1)*10^-2,'b','linewid',2);
plot(BubblePtS1(end,2),BubblePtS1(end,1)*10^-2,'ko','linewid',2)
plot(70,36,'+','color',[0,0.7,0],'linewid',2)
xlabel('Temperature [C]'),ylabel('Pressure [Bar]'),title('Separator S1')
grid

subplot(2,2,2)
hold on
plot(BubblePtS2(:,2),BubblePtS2(:,1)*10^-2,'r','linewid',2);
plot(DewPtS2(:,2),DewPtS2(:,1)*10^-2,'b','linewid',2);
plot(BubblePtS2(end,2),BubblePtS2(end,1)*10^-2,'ko','linewid',2)
plot(68.71,12,'+','color',[0,0.7,0],'linewid',2)
xlabel('Temperature [C]'),ylabel('Pressure [Bar]'),title('Separator S2')
text(-100,35,'L')
text(220,25,'L+V')
text(450,10,'V')
grid


subplot(2,2,3)
hold on
plot(BubblePtS3(:,2),BubblePtS3(:,1)*10^-2,'r','linewid',2);
plot(DewPtS3(:,2),DewPtS3(:,1)*10^-2,'b','linewid',2);
plot(BubblePtS3(end,2),BubblePtS3(end,1)*10^-2,'ko','linewid',2)
plot(66.11,2,'+','color',[0,0.7,0],'linewid',2)
xlabel('Temperature [C]'),ylabel('Pressure [Bar]'),title('Separator S3')
legend('Bubble point curve','Dew point curve','Critical point','Operation condition','Location',[0.6,0.2,0.2,0.2])
grid