% Compressor characteristic compressor 2.  
% clear 
% close all
% clc
% %clf(1)



%Discharge pressure curves
VPrC209=[352    380     420     460     500     520     540     550     560     570     575     580]*10;        %Volum flow [m3/h] 
PrC209=[128     127     125     121     115     110.2   105     101     96      88        80      68]*10^5;     %Outlet pressure [Pa] 

VPrC2095=[380   420     460     500     540     580     600     610     620     629.5]*10;
PrC2095=[146    144.5   142     138     132     122     114     107     96      75]*10^5;       

VPrC21= [420    460     500     540     580     620     640     660     669     675     679.5     ]*10;           
PrC21= [164     163     161.5   158     151     140     132     120     112     103     90      ]*10^5;     

VPrC2105= [468   510     540     560     600     640     680     707     720     728]*10;
PrC2105=  [187   186     184.2   182.6   178     169     156     142       124     90]*10^5; 

%Surge line 
VPrs=[352   380     420     468]*10;
Prs=[128    146     164     187]*10^5;

%Power at comprssor coupling curves 
VPoC209=[352    500     540     560     571     580]*10;
PoC209= [76     91.4    93.6    94.2     94      93]*10^5; 

VPoC2095=[380   540     580     600     620     630]*10;
PoC2095= [93    111   114.2   114.6   114.2   112]*10^5; 

VPoC21=[420     500     600     640     660     672     680]*10;
PoC21= [113.8   124.4   136.4   138.6   138.6   137     134.5]*10^5;

VPoC2105=[468   560     640     680     700     720     728]*10;
PoC2105= [139.5 153     161.4   164.4   164.8   162.6   159]*10^5;

% %Density to the inlet gas 
M = 22.831;                     %Molar mass [g/mol]
Z=0.880;                        %Compressibility factor
Pin=34.25*10^5;                 %Inlet Pressure [Pa] 
R=8.314472;                     %Gas constant [J/(mol*K)]
Tin=29.8+273.16;                %Absolute inlet temperature [K]
rho=Pin*M/(Z*R*Tin*10^3);       %Density [kg/m^3]

%Conversion form [m3/h] to [kg/s]
MPrC209=VPrC209*rho/3600;        %mass flow [Kg/s]
MPrC2095=VPrC2095*rho/3600;      %mass flow [Kg/s]
MPrC21=VPrC21*rho/3600;          %mass flow [Kg/s]
MPrC2105=VPrC2105*rho/3600;      %mass flow [Kg/s]
MPrs=VPrs*rho/3600;              %mass flow [Kg/s]

MPoC209=VPoC209*rho/3600;        %mass flow [Kg/s]
MPoC2095=VPoC2095*rho/3600;      %mass flow [Kg/s]
MPoC21=VPoC21*rho/3600;          %mass flow [Kg/s]
MPoC2105=VPoC2105*rho/3600;      %mass flow [Kg/s]


%Conversion for discharge prssure to pressure ratio 
PASP=34.25*10^5;         %pressure inlet [Pa]
RaC209=PrC209/PASP;      %pressure ratio 
RaC2095=PrC2095/PASP;    %pressure ratio
RaC21=PrC21/PASP;        %pressure ratio
RaC2105=PrC2105/PASP;    %pressure ratio 
Ras=Prs/PASP;            %pressure ratio 


if 0
figure(2)
plot(VPrC209*10^-1,PrC209*10^-5);
hold on
plot(VPrC2095*10^-1,PrC2095*10^-5);
hold on
plot(VPrC21*10^-1,PrC21*10^-5);
hold on
plot(VPrC2105*10^-1,PrC2105*10^-5);
axis([340,740,10,190]);
grid
end

if 1
figure(1)
subplot(2,1,1)
hold on
plot(MPrC209,RaC209,'k:','LineWidth',2);
plot(MPrC2095,RaC2095,'k:','LineWidth',2);
plot(MPrC21,RaC21,'k:','LineWidth',2);
plot(MPrC2105,RaC2105,'k:','LineWidth',2);
plot(MPrC209,RaC209,'kx','LineWidth',2);
plot(MPrC2095,RaC2095,'kx','LineWidth',2);
plot(MPrC21,RaC21,'kx','LineWidth',2);
plot(MPrC2105,RaC2105,'kx','LineWidth',2);
plot(MPrs,Ras,'r','LineWidth',2);
axis([30 75 1 6.5])
grid
xlabel('Mass flow [Kg/s]'), ylabel('Pressure ratio')
text(55.5,1.5,'0.9','FontSize',12,'FontWeight','bold')
text(61,1.8,'0.95','FontSize',12,'FontWeight','bold')
text(66.5,2.2,'1','FontSize',12,'FontWeight','bold')
text(70,2.3,'1.05','FontSize',12,'FontWeight','bold')

  
subplot(2,1,2)
hold on
plot(MPoC209,PoC209,'k:','LineWidth',2)
plot(MPoC2095,PoC2095,'k:','LineWidth',2)
plot(MPoC21,PoC21,'k:','LineWidth',2)
plot(MPoC2105,PoC2105,'k:','LineWidth',2)
plot(MPoC209,PoC209,'kx','LineWidth',2)
plot(MPoC2095,PoC2095,'kx','LineWidth',2)
plot(MPoC21,PoC21,'kx','LineWidth',2)
plot(MPoC2105,PoC2105,'kx','LineWidth',2)
axis([30 75 65e5 180e5])
grid
xlabel('Mass flow [Kg/s]'), ylabel('Power at compressor coupling [W]')
text(31.5,0.8e7,'0.9','FontSize',12,'FontWeight','bold')
text(34,1e7,'0.95','FontSize',12,'FontWeight','bold')
text(40,1.2e7,'1','FontSize',12,'FontWeight','bold')
text(43,1.50e7,'1.05','FontSize',12,'FontWeight','bold')
end

