% Compressor characteristic compressor 3.  
%clear 
%close all
%clc
%clf(1)

%Discharge pressure curves
VPrC309=[150,    180,     200,     220,  230,  237.6,    241]*10;        %Volum flow [m3/h] 
PrC309=[35.55,  33.88,   32.08,   29,   26.1,   22.4     19]*10^5;       %Outlet fressure [Psi] 

VPrC3095=[168,    190,    204,    220,    240,  249,    253,  258  260]*10;
PrC3095=[39.7    38.9   38      36.3    32.82   30,    28    24,  20.5]*10^5;       

VPrC31= [196     210     230     250     260  265     270     277]*10;           
PrC31= [44.9    44.2    42.5    39.5    37   35.4      32.6       23]*10^5;     

VPrC3105= [228    250     260     273     280   285     290     295]*10;
PrC3105= [50.3   48.6    47.3    44.8    42.3  40     36      23.8]*10^5; 

%Surge line 
VPrs=[150     168     196     228]*10;
Prs=[35.33   39.7    44.9    50.3]*10^5;

%Power at comprssor coupling curves 
VPoC309=[150    220    230  235     241]*10;
PoC309= [100    116    118  118     117]*10^4; 

VPoC3095=[168   230     250     255     260]*10;
PoC3095= [124   141     144     143     141]*10^4; 

VPoC31=[196     250     260     270     277]*10;
PoC31= [154     170     172     172     169]*10^4;

VPoC3105=[228   260     275     280     290     295]*10;
PoC3105= [192   203     206     206.5   204     198]*10^4;

%Density to the inlet gas 
M = 29.136;                     %Molar mass [g/mol]
Z=0.935;                        %Compressibility factor
Pin=10.8*10^5;                  %Inlet Pressure [Psi] 
R=8.314472;                     %Gas constant [J/(mol*K)]
Tin=28.7+273.16;                %Absolute inlet temperature [K]
rho=Pin*M/(Z*R*Tin*10^3);       %Density [kg/m^3]

% %Conversion form [m3/h] to [kg/s]
MPrC309=VPrC309*rho/3600;        %mass flow [Kg/s]
MPrC3095=VPrC3095*rho/3600;      %mass flow [Kg/s]
MPrC31=VPrC31*rho/3600;          %mass flow [Kg/s]
MPrC3105=VPrC3105*rho/3600;      %mass flow [Kg/s]
MPrs=VPrs*rho/3600;              %mass flow [Kg/s]

MPoC309=VPoC309*rho/3600;        %mass flow [Kg/s]
MPoC3095=VPoC3095*rho/3600;      %mass flow [Kg/s]
MPoC31=VPoC31*rho/3600;          %mass flow [Kg/s]
MPoC3105=VPoC3105*rho/3600;      %mass flow [Kg/s]


%Conversion for discharge prssure to pressure ratio 
PASP=10.80*10^5;         %pressure inlet [Psi]
RaC309=PrC309/PASP;      %pressure ratio 
RaC3095=PrC3095/PASP;    %pressure ratio
RaC31=PrC31/PASP;        %pressure ratio
RaC3105=PrC3105/PASP;    %pressure ratio 
Ras=Prs/PASP;            %pressure ratio 




figure(1)
subplot(2,1,1)
plot(MPrC309,RaC309,'k','LineWidth',2);
hold on
plot(MPrC3095,RaC3095,'k','LineWidth',2);
hold on
plot(MPrC31,RaC31,'k','LineWidth',2);
hold on
plot(MPrC3105,RaC3105,'k','LineWidth',2);
hold on
plot(MPrs,Ras,'k--','LineWidth',2);
axis([5 12 1.5 5])
grid
xlabel('Mass flow [Kg/s]'), ylabel('Pressure ratio')
text(9,2,'0.9','FontSize',12,'FontWeight','bold')
text(9,3.2,'0.95','FontSize',12,'FontWeight','bold')
text(9,3.9,'1','FontSize',12,'FontWeight','bold')
text(9,4.7,'1.05','FontSize',12,'FontWeight','bold')



subplot(2,1,2)
plot(MPoC309,PoC309,'k','LineWidth',2)
hold on
plot(MPoC3095,PoC3095,'k','LineWidth',2)
hold on
plot(MPoC31,PoC31,'k','LineWidth',2)
hold on
plot(MPoC3105,PoC3105,'k','LineWidth',2)
axis([5 12 0.9*10^6 2.2*10^6])
grid
xlabel('Mass flow [Kg/s]'), ylabel('Power at compressor coupling [W]')
text(5.5,1.07e6,'0.9','FontSize',12,'FontWeight','bold')
text(6.3,1.33e6,'0.95','FontSize',12,'FontWeight','bold')
text(7.5,1.62e6,'1','FontSize',12,'FontWeight','bold')
text(8.5,2.02e6,'1.05','FontSize',12,'FontWeight','bold')

