%Polynomial approximation of the power consumption.

clc
comcharC4
close all

%Least Squares Approximation (Power=c1*m+c2*Pr+c3)
A=[MPoC425(1),  RaC425(1),  1;
   MPoC425(2),  RaC425(4),  1;
   MPoC435(1),  RaC435(1),  1;
   MPoC435(2),  RaC435(4),  1;
   MPoC443(1),  RaC443(1),  1;
   MPoC443(4),  RaC443(4),  1;
   MPoC465(1),  RaC465(1),  1;
   MPoC465(4),  RaC465(6),  1;
   MPoC4105(1), RaC4105(1), 1;
   MPoC4105(6), RaC4105(8), 1;]
b=[PoC425(1);PoC425(2);PoC435(1);PoC435(2);PoC443(1);PoC443(4);PoC465(1);PoC465(4);PoC4105(1);PoC4105(6)]
x=A\b

Apo=A*x;
Apo4105(3)=x(1)*MPoC4105(3)+x(2)*RaC4105(4)+x(3);
Apo4105(4)=x(1)*MPoC4105(4)+x(2)*RaC4105(5)+x(3);
Apo4105(5)=x(1)*MPoC4105(5)+x(2)*RaC4105(6)+x(3);
Apo4105(2)=x(1)*MPoC4105(2)+x(2)*interp1(MPrC4105,RaC4105,MPoC4105(2),'linear')+x(3);
ApoC465(2)=x(1)*MPoC465(2)+x(2)*RaC465(3)+x(3);
ApoC465(3)=x(1)*MPoC465(3)+x(2)*interp1(MPrC465,RaC465,MPoC465(3),'linear')+x(3);
ApoC443(2)=x(1)*MPoC443(2)+x(2)*interp1(MPrC443,RaC443,MPoC443(2),'linear')+x(3);
ApoC443(3)=x(1)*MPoC443(3)+x(2)*interp1(MPrC443,RaC443,MPoC443(3),'linear')+x(3);

Prmax=[14.34,14.34,RaC4105(3:end)];
mmax =[0,5.737,MPrC4105(3:end)];

mvec=[0:0.01:7];
for i=1:size(mvec,2);
    Pvec(i)=interp1(mmax,Prmax,mvec(i),'linear','extrap');
end

%Surge avoidance line
C1=2.5;
C2=0;
mvec2=[0:0.01:5.75];
Prsa=C1*mvec2+C2




figure(1)
subplot(2,1,1)
hold on
plot(mvec,Pvec,'linewid',2)
plot(MPrC425,RaC425,'kx','LineWidth',2);
plot(MPrC425,RaC425,'k--');
plot(MPrC435,RaC435,'kx','LineWidth',2);
plot(MPrC435,RaC435,'k--');
plot(MPrC443,RaC443,'kx','LineWidth',2);
plot(MPrC443,RaC443,'k--');
plot(MPrC465,RaC465,'kx','LineWidth',2);
plot(MPrC465,RaC465,'k--');
plot(MPrC4105,RaC4105,'kx','LineWidth',2);
plot(MPrC4105,RaC4105,'k--');
plot(mvec2,Prsa,'r','linewid',2);

axis([2.5 7 2 16])
grid
xlabel('Mass flow [Kg/s]'), ylabel('Pressure ratio')
text(3,5,'25\circ','FontSize',12,'FontWeight','bold')
text(3.8,5,'35\circ','FontSize',12,'FontWeight','bold')
text(4.8,5,'43\circ','FontSize',12,'FontWeight','bold')
text(5.8,7,'65\circ','FontSize',12,'FontWeight','bold')
text(6.5,13,'105\circ','FontSize',12,'FontWeight','bold')



subplot(2,1,2)
hold on
plot(MPoC425,PoC425,'kx','LineWidth',2)
plot(MPoC425,PoC425,'k--')
plot(MPoC435,PoC435,'kx','LineWidth',2)
plot(MPoC435,PoC435,'k--')
plot(MPoC443,PoC443,'kx','LineWidth',2)
plot(MPoC443,PoC443,'k--')
plot(MPoC465,PoC465,'kx','LineWidth',2)
plot(MPoC465,PoC465,'k--')
plot(MPoC4105,PoC4105,'kx','LineWidth',2)
plot(MPoC4105,PoC4105,'k--')

plot(A(:,1),Apo,'x','linewidth',2);

plot(MPoC4105(2),Apo4105(2),'bx','linewidth',2);
plot(MPoC4105(3),Apo4105(3),'bx','linewidth',2);
plot(MPoC4105(4),Apo4105(4),'bx','linewidth',2);
plot(MPoC4105(5),Apo4105(5),'bx','linewidth',2);

plot(MPoC465(2),ApoC465(2),'bx','linewidth',2);
plot(MPoC465(3),ApoC465(3),'bx','linewidth',2);

plot(MPoC443(2),ApoC443(2),'bx','linewidth',2);
plot(MPoC443(3),ApoC443(3),'bx','linewidth',2);

% plot(A(1:2,1),Apo(1:2),'--')
% plot(A(3:4,1),Apo(3:4),'--')
% plot(A(5:6,1),Apo(5:6),'--')
% plot(A(7:8,1),Apo(7:8),'--')
% plot(A(9:10,1),Apo(9:10),'--')
axis([2.5 7 0.5e6 1.8e6])
grid
xlabel('Mass flow [Kg/s]'), ylabel('Power at compressor coupling [W]')
text(3,0.7e6,'25\circ','FontSize',12,'FontWeight','bold')
text(3.7,0.95e6,'35\circ','FontSize',12,'FontWeight','bold')
text(4.8,1e6,'43\circ','FontSize',12,'FontWeight','bold')
text(5.8,1.2e6,'65\circ','FontSize',12,'FontWeight','bold')
text(6.5,1.3e6,'105\circ','FontSize',12,'FontWeight','bold')

   
   