%Test of function sscompresor.m 
clear
comcharC2
close all
clc


%Compressor C2
Nc=[0.9:0.05:1.05]   %Relative compressor speed
Ti=29.8+273.15;      %Inlet temprature [k]
MW=22.831;           %Molecular weight 
pi=34.25*10^5;       %Inlet pressure [Pa]
Com=2;
Ncv(1).m=[32:0.1:57.3];
Ncv(2).m=[35:0.1:62.3];
Ncv(3).m=[40:0.1:67.2];
Ncv(4).m=[42:0.1:72.4];

for i=1:size(Nc,2)
    for j=1:size(Ncv(i).m,2)
    [Ncv(i).pd(j),Ncv(i).Power(j)]=sscomdim1(Ncv(i).m(j),Nc(i),pi,Ti,MW,Com)
    end
end


figure(1)
subplot(2,2,1)
hold on
axis([30 75 1.5 6])
grid
xlabel('Mass flow [Kg/s]'), ylabel('Pressure ratio'),title('Compressor C2')

subplot(2,2,3)
hold on
axis([30 75 0.7e7 1.7e7])
grid
xlabel('Mass flow [Kg/s]'), ylabel('Power consumption  [W]')

subplot(2,2,1)
plot(Ncv(1).m,Ncv(1).pd/pi,'linewid',2)
plot(Ncv(2).m,Ncv(2).pd/pi,'linewid',2)
plot(Ncv(3).m,Ncv(3).pd/pi,'linewid',2)
plot(Ncv(4).m,Ncv(4).pd/pi,'linewid',2)
plot(MPrC209,RaC209,'kx','linewid',2)
plot(MPrC2095,RaC2095,'kx','linewid',2)
plot(MPrC21,RaC21,'kx','linewid',2)
plot(MPrC2105,RaC2105,'kx','linewid',2)

subplot(2,2,3)
plot(Ncv(1).m,Ncv(1).Power,'linewid',2)
plot(Ncv(2).m,Ncv(2).Power,'linewid',2)
plot(Ncv(3).m,Ncv(3).Power,'linewid',2)
plot(Ncv(4).m,Ncv(4).Power,'linewid',2)
plot(MPoC209,PoC209,'kx','linewid',2)
plot(MPoC2095,PoC2095,'kx','linewid',2)
plot(MPoC21,PoC21,'kx','linewid',2)
plot(MPoC2105,PoC2105,'kx','linewid',2)

%Compressor C3
clear Ncv
Nc=[0.9:0.05:1.05]   %Relative compressor speed
Ti=29.1+273.15;      %Inlet temprature [k]
MW=29.136            %Molecular weight 
pi=10.8*10^5;        %Inlet pressure [Pa]
Com=3;
Ncv(1).m=[5.3:0.01:9.2];
Ncv(2).m=[6:0.01:10];
Ncv(3).m=[6.8:0.01:10.6];
Ncv(4).m=[7.1:0.01:11.2];

for i=1:size(Nc,2)
    for j=1:size(Ncv(i).m,2)
    [Ncv(i).pd(j),Ncv(i).Power(j)]=sscomdim1(Ncv(i).m(j),Nc(i),pi,Ti,MW,Com);
    end
end

comcharC32

subplot(2,2,2)
hold on
axis([5 12 1.5 5])
grid
xlabel('Mass flow [Kg/s]'), ylabel('Pressure ratio'),title('Compressor C3')

subplot(2,2,4)
hold on
axis([5 12 0.8e6 2.2e6])
grid
xlabel('Mass flow [Kg/s]'), ylabel('Power consumption  [W]')

subplot(2,2,2)
plot(Ncv(1).m,Ncv(1).pd/pi,'linewid',2)
plot(Ncv(2).m,Ncv(2).pd/pi,'linewid',2)
plot(Ncv(3).m,Ncv(3).pd/pi,'linewid',2)
plot(Ncv(4).m,Ncv(4).pd/pi,'linewid',2)
plot(MPrC309,RaC309,'kx','linewid',2)
plot(MPrC3095,RaC3095,'kx','linewid',2)
plot(MPrC31,RaC31,'kx','linewid',2)
plot(MPrC3105,RaC3105,'kx','linewid',2)

subplot(2,2,4)
plot(Ncv(1).m,Ncv(1).Power,'linewid',2)
plot(Ncv(2).m,Ncv(2).Power,'linewid',2)
plot(Ncv(3).m,Ncv(3).Power,'linewid',2)
plot(Ncv(4).m,Ncv(4).Power,'linewid',2)
plot(MPoC309,PoC309,'kx','linewid',2)
plot(MPoC3095,PoC3095,'kx','linewid',2)
plot(MPoC31,PoC31,'kx','linewid',2)
plot(MPoC3105,PoC3105,'kx','linewid',2)


