function f=objcch2(X,C)

Ti=C.Constants(1);        %Inlet temprature [k]
MW=C.Constants(2);        %molecular weight 
pi=C.Constants(3);        %Inlet pressure [Pa]
Sflow=C.Constants(4);      %Scale the flow coefficient 
 
for i=[1:4]
S(i).flowc=Sflow*C.S(i).Coms(3,:)*Ti^0.5*pi^-1*MW^-.5*C.S(i).Speed^-X(1);   %Flow coefficient
S(i).pressc=C.S(i).Coms(1,:)*C.S(i).Speed^-X(2);                            %Pressure coefficient
S(i).powc=C.S(i).Coms(2,:)*MW^0.5*pi^-1*Ti^-0.5*C.S(i).Speed^-X(3);         %Power coefficient
end

Z1=[S(1).flowc,S(2).flowc,S(3).flowc,S(4).flowc;S(1).pressc,S(2).pressc,S(3).pressc,S(4).pressc];
Z1s=(sortrows(Z1',1))';
[Ppres,Spres,MUpres]=polyfit(Z1s(1,:),Z1s(2,:),9);

Z2=[S(1).flowc,S(2).flowc,S(3).flowc,S(4).flowc;S(1).powc,S(2).powc,S(3).powc,S(4).powc];
Z1s=(sortrows(Z2',1))';
[Ppow,Spow,MUpow]=polyfit(Z1s(1,:),Z1s(2,:),9);

f=Spres.normr+Spow.normr;
end
