%Polynomial approximation compressor characteristics 1. 
clc
comcharC2

%Compressor C2
C2.S(1).Com    =[MPrC209/50;RaC209;];
C2.S(1).Power  =[MPoC209/50;PoC209];

C2.S(2).Com    =[MPrC2095/50;RaC2095;];
C2.S(2).Power  =[MPoC2095/50;PoC2095];

C2.S(3).Com    =[MPrC21/50;RaC21;];
C2.S(3).Power  =[MPoC21/50;PoC21];

C2.S(4).Com    =[MPrC2105/50;RaC2105;];
C2.S(4).Power  =[MPoC2105/50;PoC2105];

Speed=[0.9,0.95,1,1.05];

clearvars -regexp ^*$ -except C2 rho Speed
close all

% Shape-preserving piecewise cubic interpolation of compressor chrateristics 
for i=[1:4]
    minx=min([C2.S(i).Power(1,1),C2.S(i).Com(1,1)]);
    maxx=max([C2.S(i).Power(1,end),C2.S(i).Com(1,end)]);
    X=[minx:0.001:maxx];
    Pratio =interp1(C2.S(i).Com(1,:),C2.S(i).Com(2,:),X,'pchip');
    Power  =interp1(C2.S(i).Power(1,:),C2.S(i).Power(2,:),X,'pchip');
    C2.S(i).Coms=[Pratio;Power;X];
end

rowsA=size(C2.S(1).Coms(1,:),2)+size(C2.S(2).Coms(1,:),2)+size(C2.S(3).Coms(1,:),2)+size(C2.S(4).Coms(1,:),2);
columnsA=9; 
columnsd=1;
A=zeros(rowsA,columnsA);
d=zeros(rowsA,columnsd);

k=1;
for i=1:4
    for j=1:size(C2.S(i).Coms(1,:),2)
        S=0.85+0.05*i;
        m=C2.S(i).Coms(3,j);
        Sv=[S^2 S 1];
        A(k,:)=[Sv*m^3 Sv*m Sv];
        d(k)=C2.S(i).Coms(1,j);
        k=k+1;
    end
end

%Least-square problem
c=A\d;

%Plot of original compressor chrateristics
    for i=[1:1]
    figure(i)
    hold on 
    grid
    axis([0.65 1.5 1.5 6])
    xlabel('Mass flow [Kg/s]'), ylabel('Pressure ratio')
    
    end
    for i=[1:4]
        figure(1)
        plot(C2.S(i).Coms(3,:),C2.S(i).Coms(1,:),'--k','linewid',2)
        plot(C2.S(i).Com(1,:),C2.S(i).Com(2,:),'kx','linewid',2)
    end

    
%Plot of polynomial approximation compressor chrateristics
Speed=[0.9 0.95 1 1.05];
for j=1:4
    mtot=[C2.S(j).Coms(3,1):0.001:C2.S(j).Coms(3,end)+3];
    for k=0:2
        d(k+1)=c(1+k*3)*Speed(j)^2+c(2+k*3)*Speed(j)+c(3+k*3);
    end
    for i=1:size(mtot,2);
        m=mtot(i);
        Pr(i)=d(1)*m^3+d(2)*m +d(3);
    end
    plot(mtot,Pr,'k','linewid',2)    
end











