%Polynomial approximation compressor characteristics 2. 
clc
comcharC2

%Compressor C2
C2.S(1).Com    =[MPrC209;RaC209;];
C2.S(1).Power  =[MPoC209;PoC209];

C2.S(2).Com    =[MPrC2095;RaC2095;];
C2.S(2).Power  =[MPoC2095;PoC2095];

C2.S(3).Com    =[MPrC21;RaC21;];
C2.S(3).Power  =[MPoC21;PoC21];

C2.S(4).Com    =[MPrC2105;RaC2105;];
C2.S(4).Power  =[MPoC2105;PoC2105];

Speed=[0.9,0.95,1,1.05];

clearvars -regexp ^*$ -except C2 rho Speed
close all

% Shape-preserving piecewise cubic interpolation of compressor chrateristics 
for i=[1:4]
    minx=min([C2.S(i).Power(1,1),C2.S(i).Com(1,1)]);
    maxx=max([C2.S(i).Power(1,end),C2.S(i).Com(1,end)]);
    X=[minx:0.1:maxx];
    Pratio =interp1(C2.S(i).Com(1,:),C2.S(i).Com(2,:),X,'pchip');
    Power  =interp1(C2.S(i).Power(1,:),C2.S(i).Power(2,:),X,'pchip');
    C2.S(i).Coms=[Pratio;Power;X];
end


max(1)=find(C2.S(1).Coms(3,:)>54,1,'first');
max(2)=find(C2.S(2).Coms(3,:)>57.5,1,'first');
max(3)=find(C2.S(3).Coms(3,:)>61.5,1,'first');
max(4)=find(C2.S(4).Coms(3,:)>66,1,'first');

rowsA=sum(max);
columnsA=9; 
columnsd=1;
A=zeros(rowsA,columnsA);
d=zeros(rowsA,columnsd);

k=1;
for i=1:4
    for j=1:size(C2.S(i).Coms(1,[1:max(i)]),2)
        S=0.85+0.05*i;
        m=C2.S(i).Coms(3,j);
        A(k,:)=[S^2*m^3, S*m^3, m^3 S^2*m^2, S*m^2, m^2, S^2, S 1];
        d(k)=C2.S(i).Coms(1,j);
        k=k+1;
    end
end

%Least-square problem
c=A\d;

%Plot of original compressor chrateristics
    for i=[1:1]
    figure(i)
    hold on 
    grid
    axis([30 75 1.5 6])
    xlabel('Mass flow [Kg/s]'), ylabel('Pressure ratio')
    
    end
    for i=[1:4]
        figure(1)
        plot(C2.S(i).Coms(3,:),C2.S(i).Coms(1,:),'--k','linewid',2)
        plot(C2.S(i).Com(1,:),C2.S(i).Com(2,:),'kx','linewid',2)
        plot(C2.S(i).Coms(3,max(i)),C2.S(i).Coms(1,max(i)),'ko','linewid',2)
    end

    
%Plot of polynomial approximation compressor chrateristics
Speed=[0.9 0.95 1 1.05];
for j=1:4
     mtot=[C2.S(j).Coms(3,1):0.1:C2.S(j).Coms(3,end)+3];
    for i=1:size(mtot,2);
        m=mtot(i);
        Pr(i)=(c(1)*Speed(j)^2+c(2)*Speed(j)+c(3))*m^3+(c(4)*Speed(j)^2+c(5)*Speed(j)+c(6))*m^2+(c(7)*Speed(j)^2+c(8)*Speed(j)+c(9));
    end
    plot(mtot,Pr,'k','linewid',2)    
end

figure(2)
Speed=[0.9:0.01:1.05]
for j=1:size(Speed,2)
    c1kof(j)=c(1)*Speed(j)^2+c(2)*Speed(j)+c(3);
    c2kof(j)=c(4)*Speed(j)^2+c(5)*Speed(j)+c(6);
    c3kof(j)=c(7)*Speed(j)^2+c(8)*Speed(j)+c(9);
end
plot(Speed,c1kof)
figure(3)
plot(Speed,c2kof)
figure(4)
plot(Speed,c3kof)

    
    
    
    









