%API and density under standard conditions (14.7 psia and 60F)

function [API,rho_oil]=API(x,Tc,Pc,w,kij,MW)

%Constants 
P=101353;        %Pressure [Pa]
T=288.606;       %Temprature[K]
R=8314.472;      %Ideal gas universal constant [J/mol)]
rho_water=998;   %Densety water 

%Number of component in feed. 
nc   = size(x,2);

[phil,Zliq] = Phi(P,T,x,Tc,Pc,w,kij,R,nc,'liquid');

MWf=sum(MW.*x);
rho_oil=P/(R*T)*(MWf/Zliq); %Density

SG=rho_oil/rho_water;      %Specific Gravity;
API=141.5/SG-131.5;        %API;

end


