%Brute force optimization of a multistage crude oil production plant with
%compression

clc
clear
close all
tic

%Inlet conditions
Flowin1=12000; %[Kg mol/h]
Flowin2=6000;
Flowin3=4000;
Flowin4=14000;

z1 = [2.071 59.58 11.40 7.984 0.784 2.193 0.358 0.412 0.218 15]; %Fluid 1
z2 = [1.706 49.06 9.390 6.577 0.646 1.806 0.295 0.340 0.180 30]; %Fluid 2
z3 = [1.341 38.55 7.377 5.167 0.507 1.419 0.232 0.266 0.141 45]; %Fluid 3 
z4 = [1.832 61.87 12.74 7.053 0.693 1.940 0.316 0.364 0.192 13]; %Fluid 4

z=z2;
Flowin=Flowin2;

%Optimization varibales
P1=[35:1:45]*10^5;
P2=[7:1:22]*10^5;
Nc=[0.9:0.01:1.05];
PrC4=[4:0.5:9];
N=size(P1,2)*size(P2,2)*size(Nc,2)*size(PrC4,2);

Imat=zeros(size(P1,2),size(P2,2));
Ncmat=zeros(size(P1,2),size(P2,2));

Profit_old=0;
for i=1:size(P1,2)
    for j=1:size(P2,2)
        Profit2=0;
        incom2=0;
        Expenses2=2;
        Nc2=0.0;
        PrC42=0;
        for k=1:size(Nc,2)
            [incom,mvvec,Fvvec,yvec]=Separators(P1(i),P2(j),z,Flowin);
             
            for l=1:size(PrC4,2)
                [Expenses,U1,U2,PoutC2,PrC2,PrC3,nonco]=compressors(P1(i),P2(j),Nc(k),PrC4(l),mvvec,Fvvec,yvec);
                if U1<=1 && U1>=0 && U2<=1  && U2>=0 && PrC2>2 && PrC3>2 && PoutC2>148*10^5 && nonco<0  
                    Profit=incom-Expenses;
                else
                    Profit=0;
                end

                if Profit>Profit_old
                    Setpoint_new=[P1(i),P2(j),Nc(k),PrC4(l),incom,Expenses,Profit];
                    Profit_old=Profit
                    P1(i)
                    P2(j)
                    Nc(k)
                    PrC4(l)
                end

                if Profit>Profit2
                    Profit2=Profit;
                    Expenses2=Expenses;
                    incom2=incom;
                    Nc2=Nc(k);
                    PrC42=PrC4(l);
                end
            end
        end
        
        if P1(i)==36*10^5 & P2(j)==12*10^5
            Setpoint_old=[P1(i),P2(j),Nc2,PrC42,incom2,Expenses2,Profit2];
        end
        
        Imat(i,j)=Profit2;
        Ncmat(i,j)=Nc2;
    end
end

Imats=sort(Imat(:))
min=Imats(find(Imats>0,1,'first'))
max=Imats(end)
Imat2=size(Imat)

for i=1:size(Imat,1)
    for j=1:size(Imat,2)
        if Imat(i,j)==0
            Imat2(i,j)=min-0.3;
        else
            Imat2(i,j)=Imat(i,j);
        end
    end
end
        
for i=1:8
    N(i)=min-0.3+(i*(max-(min-0.3)))/8;
end

figure(1)
hold on
pcolor(P2*10^-5,P1*10^-5,Imat2)
shading flat 
xlabel('Pressure separator S2 [bar]'), ylabel('Pressure separator S1 [bar]')
hcb=colorbar('Ytick',[N(1),N(2),N(3),N(4),N(5),N(6),N(7)],'YTickLabel',{'Infeasible',N(2),N(3),N(4),N(5),N(6),N(7)})
set(hcb,'YTickMode','manual')
plot(Setpoint_new(2)*10^-5,Setpoint_new(1)*10^-5,'wo','linewid',2)
plot(Setpoint_old(2)*10^-5,Setpoint_old(1)*10^-5,'ko','linewid',2)
axis([P2(1),P2(end),P1(1),P1(end)]*10^-5)

figure(2)
pcolor(P2*10^-5,P1*10^-5, Ncmat)

toc
