%Steady state compressor model 

function [pd,Power]=sscomdim2(min,Nc,pi,Ti,MW,Com)

if Com==2
%Constants for compressor C2  
Sflow=0.3e5;                                                         %Scale the flow coefficient 
exs=[1.4800    2.5704   3.6917];                                     %Exponents of Nc
ca= [-2.9532   12.3330  -17.5687   13.3420  5.4        1.94     6 ]; %Pressure coefficient
cb= [-2.0121   16.0453  -51.0342   80.8353  -63.3700   20.4411];     %Flow coefficient
Flowcsurge=1.45;
end

if Com==3
%Constants for compressor C2  
Sflow=0.3e5;                                                         %Scale the flow coefficient 
exs=[1.3168    2.7378    3.6754];                                    %Exponents of Nc
ca= [-40.6294   78.3467  -51.5891   15.7665  9.05        0.82    6]; %Pressure coefficient
cb= [-101.3003  362.4265 -517.0409  367.6043 -129.9734   18.6633];   %Flow coefficient 
Flowcsurge=0.67;
end

Flowc=(Sflow*min*(Ti)^0.5)/(pi*MW^0.5*Nc^exs(1));                   

%Anti surge controller
if Flowc<Flowcsurge
    Flowc=Flowcsurge;
end

if ca(6)>Flowc
    Pressc=ca(1)*Flowc^3+ca(2)*Flowc^2+ca(3)*Flowc+ca(4);
else
    Pressc=ca(1)*Flowc^3+ca(2)*Flowc^2+ca(3)*Flowc+ca(4)-(ca(5)*(Flowc-ca(6)))^ca(7);
end
pd=Pressc*pi*Nc^exs(2);
Powc=cb(1)*Flowc^5+cb(2)*Flowc^4+cb(3)*Flowc^3+cb(4)*Flowc^2+cb(5)*Flowc+cb(6);
Power=(pi*Ti^0.5*Nc^exs(3)*Powc)/MW^0.5;
end